diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/desktop.c vnc_unixsrc/vncviewer/desktop.c
--- vnc_unixsrc.orig/vncviewer/desktop.c	2004-05-28 13:29:29.000000000 -0400
+++ vnc_unixsrc/vncviewer/desktop.c	2010-02-25 22:32:49.000000000 -0500
@@ -152,42 +1553,529 @@
 static void
 HandleBasicDesktopEvent(Widget w, XtPointer ptr, XEvent *ev, Boolean *cont)
 {
-  int i;
+	int x, y, width, height;
+	double now = dnow();
 
-  switch (ev->type) {
+	if (w || ptr || cont) {}
+
+	if (0) {
+		PR_EXPOSE;
+	}
 
+
+  switch (ev->type) {
   case Expose:
   case GraphicsExpose:
     /* sometimes due to scrollbars being added/removed we get an expose outside
        the actual desktop area.  Make sure we don't pass it on to the RFB
        server. */
+	x = ev->xexpose.x;
+	y = ev->xexpose.y;
+	width  = ev->xexpose.width;
+	height = ev->xexpose.height;
+
+	if (image_scale) {
+		int i;
+		x /= scale_factor_x;
+		y /= scale_factor_y;
+		width  /= scale_factor_x;
+		height /= scale_factor_y;
+		/* make them a little wider to avoid painting errors */
+		for (i=0; i < 3; i++) {
+			if (x > 0) x--;
+			if (y > 0) y--;
+		}
+		for (i=0; i < 6; i++) {
+			if (x + width  < si.framebufferWidth)   width++;
+			if (y + height < si.framebufferHeight)  height++;
+		}
+	}
 
-    if (ev->xexpose.x + ev->xexpose.width > si.framebufferWidth) {
-      ev->xexpose.width = si.framebufferWidth - ev->xexpose.x;
-      if (ev->xexpose.width <= 0) break;
-    }
-
-    if (ev->xexpose.y + ev->xexpose.height > si.framebufferHeight) {
-      ev->xexpose.height = si.framebufferHeight - ev->xexpose.y;
-      if (ev->xexpose.height <= 0) break;
-    }
-
-    SendFramebufferUpdateRequest(ev->xexpose.x, ev->xexpose.y,
-				 ev->xexpose.width, ev->xexpose.height, False);
-    break;
+	if (x + width > si.framebufferWidth) {
+		width = si.framebufferWidth - x;
+		if (width <= 0) {
+			break;
+		}
+	}
+
+	if (y + height > si.framebufferHeight) {
+		height = si.framebufferHeight - y;
+		if (height <= 0) {
+			break;
+		}
+	}
+
+	if (appData.useXserverBackingStore) {
+		SendFramebufferUpdateRequest(x, y, width, height, False);
+	} else {
+		int ok = 1;
+		double delay = 2.5;
+		if (appData.fullScreen && now < last_fullscreen + delay) {
+			int xmax = si.framebufferWidth;
+			int ymax = si.framebufferHeight;
+			if (appData.yCrop > 0) {
+				ymax = appData.yCrop;
+			}
+			xmax = scale_round(xmax, scale_factor_x);
+			ymax = scale_round(ymax, scale_factor_y);
+			if (dpyWidth < xmax) {
+				xmax = dpyWidth;
+			}
+			if (dpyHeight < ymax) {
+				ymax = dpyHeight;
+			}
+			if (x != 0 && y != 0) {
+				ok = 0;
+			}
+			if (width < 0.9 * xmax) {
+				ok = 0;
+			}
+			if (height < 0.9 * ymax) {
+				ok = 0;
+			}
+		}
+		if (appData.yCrop > 0) {
+			if (now < last_fullscreen + delay || now < last_rescale + delay) {
+				if (y + height > appData.yCrop) {
+					height = appData.yCrop - y;
+				}
+			}
+		}
+		if (ok) {
+			put_image(x, y, x, y, width, height, 0);
+			XSync(dpy, False);
+		} else {
+			fprintf(stderr, "Skip ");
+			PR_EXPOSE;
+		}
+	}
+	break;
 
   case LeaveNotify:
-    for (i = 0; i < 256; i++) {
-      if (modifierPressed[i]) {
-	SendKeyEvent(XKeycodeToKeysym(dpy, i, 0), False);
-	modifierPressed[i] = False;
-      }
-    }
-    break;
+	releaseAllPressedModifiers();
+	if (appData.fullScreen) {
+		fs_ungrab(1);
+	}
+	break;
+  case EnterNotify:
+	if (appData.fullScreen) {
+		fs_grab(1);
+	}
+	break;
+  case ClientMessage:
+	if (ev->xclient.window == XtWindow(desktop) && ev->xclient.message_type == XA_INTEGER &&
+	    ev->xclient.format == 8 && !strcmp(ev->xclient.data.b, "SendRFBUpdate")) {
+		SendIncrementalFramebufferUpdateRequest();
+	}
+	break;
   }
+	check_things();
+}
+
+extern Position desktopX, desktopY;
+
+void x11vnc_appshare(char *cmd) {
+	char send[200], str[100];
+	char *id = "cmd=id_cmd";
+	int m_big = 80, m_fine = 15;
+	int resize = 100, db = 0;
+
+	if (getenv("X11VNC_APPSHARE_DEBUG")) {
+		db = atoi(getenv("X11VNC_APPSHARE_DEBUG"));
+	}
+
+	if (db) fprintf(stderr, "x11vnc_appshare: cmd=%s\n", cmd);
+
+	str[0] = '\0';
+
+	if (!strcmp(cmd, "left")) {
+		sprintf(str, "%s:move:-%d+0", id, m_big);
+	} else if (!strcmp(cmd, "right")) {
+		sprintf(str, "%s:move:+%d+0", id, m_big);
+	} else if (!strcmp(cmd, "up")) {
+		sprintf(str, "%s:move:+0-%d", id, m_big);
+	} else if (!strcmp(cmd, "down")) {
+		sprintf(str, "%s:move:+0+%d", id, m_big);
+	} else if (!strcmp(cmd, "left-fine")) {
+		sprintf(str, "%s:move:-%d+0", id, m_fine);
+	} else if (!strcmp(cmd, "right-fine")) {
+		sprintf(str, "%s:move:+%d+0", id, m_fine);
+	} else if (!strcmp(cmd, "up-fine")) {
+		sprintf(str, "%s:move:+0-%d", id, m_fine);
+	} else if (!strcmp(cmd, "down-fine")) {
+		sprintf(str, "%s:move:+0+%d", id, m_fine);
+	} else if (!strcmp(cmd, "taller")) {
+		sprintf(str, "%s:resize:+0+%d", id, resize);
+	} else if (!strcmp(cmd, "shorter")) {
+		sprintf(str, "%s:resize:+0-%d", id, resize);
+	} else if (!strcmp(cmd, "wider")) {
+		sprintf(str, "%s:resize:+%d+0", id, resize);
+	} else if (!strcmp(cmd, "narrower")) {
+		sprintf(str, "%s:resize:-%d+0", id, resize);
+	} else if (!strcmp(cmd, "lower")) {
+		sprintf(str, "%s:lower", id);
+	} else if (!strcmp(cmd, "raise")) {
+		sprintf(str, "%s:raise", id);
+	} else if (!strcmp(cmd, "delete")) {
+		sprintf(str, "%s:wm_delete", id);
+	} else if (!strcmp(cmd, "position")) {
+		Position x, y;
+		int xi, yi;
+
+		XtVaGetValues(toplevel, XtNx, &x, XtNy, &y, NULL);
+		xi = (int) x;
+		yi = (int) y;
+		if (appData.scale) {
+			double fx = 1.0, fy = 1.0;
+			get_scale_values(&fx, &fy);
+			if (fx > 0.0 && fy > 0.0) {
+				xi /= fx;
+				yi /= fx;
+			}
+		}
+		sprintf(str, "%s:geom:0x0+%d+%d", id, xi, yi);
+		fprintf(stderr, "str=%s\n", str);
+	}
+	if (strcmp(str, "")) {
+		Bool vo = appData.viewOnly;
+		strcpy(send, "X11VNC_APPSHARE_CMD:");
+		strcat(send, str);
+		if (db) fprintf(stderr, "x11vnc_appshare: send=%s\n", send);
+		if (vo) appData.viewOnly = False;
+		SendClientCutText(send, strlen(send));
+		if (vo) appData.viewOnly = True;
+	}
+}
+
+void scroll_desktop(int horiz, int vert, double amount) {
+	Dimension h, w;
+	Position x, y;
+	Position x2, y2;
+	static int db = -1;
+
+	if (db < 0) {
+		if (getenv("SSVNC_DEBUG_ESCAPE_KEYS")) {
+			db = 1;
+		} else {
+			db = 0;
+		}
+	}
+
+	XtVaGetValues(form, XtNheight, &h, XtNwidth, &w, NULL);
+	XtVaGetValues(desktop, XtNx, &x, XtNy, &y, NULL);
+
+	x2 = -x;
+	y2 = -y;
+
+	if (amount == -1.0) {
+		int dx = horiz;
+		int dy = vert;
+		if (dx == 0 && dy == 0) {
+			return;
+		}
+		x2 -= dx;
+		y2 -= dy;
+	} else {
+		if (horiz) {
+			int dx = (int) (amount * w);
+			if (dx < 0) dx = -dx;
+			if (amount == 0.0) dx = 1;
+			if (horiz > 0) {
+				x2 += dx;
+			} else {
+				x2 -= dx;
+			}
+			if (x2 < 0) x2 = 0;
+		}
+		if (vert) {
+			int dy = (int) (amount * h);
+			if (amount == 0.0) dy = 1;
+			if (dy < 0) dy = -dy;
+			if (vert < 0) {
+				y2 += dy;
+			} else {
+				y2 -= dy;
+			}
+			if (y2 < 0) y2 = 0;
+		}
+	}
+
+	if (db) fprintf(stderr, "%d %d %f viewport(%dx%d): %d %d -> %d %d\n", horiz, vert, amount, w, h, -x, -y, x2, y2); 
+	XawViewportSetCoordinates(viewport, x2, y2);
+
+	if (appData.fullScreen) {
+		XSync(dpy, False);
+		XtVaGetValues(desktop, XtNx, &x, XtNy, &y, NULL);
+		desktopX = -x;
+		desktopY = -y;
+	} else if (amount == -1.0) {
+		XSync(dpy, False);
+	}
 }
 
+void scale_desktop(int bigger, double frac) {
+	double current, new;
+	char tmp[100];
+	char *s;
+	int fs;
+
+	if (appData.scale == NULL) {
+		s = "1.0";
+	} else {
+		s = appData.scale;
+	}
+	if (!strcmp(s, "auto")) {
+		fprintf(stderr, "scale_desktop: skipping scale mode '%s'\n", s);
+		return;
+	} else if (!strcmp(s, "fit")) {
+		fprintf(stderr, "scale_desktop: skipping scale mode '%s'\n", s);
+		return;
+	} else if (strstr(s, "x")) {
+		fprintf(stderr, "scale_desktop: skipping scale mode '%s'\n", s);
+		return;
+	} else if (!strcmp(s, "none")) {
+		s = "1.0";
+	}
+
+	if (sscanf(s, "%lf", &current) != 1) {
+		fprintf(stderr, "scale_desktop: skipping scale mode '%s'\n", s);
+		return;
+	}
+	if (bigger) {
+		new = current * (1.0 + frac);
+	} else {
+		new = current / (1.0 + frac);
+	}
+	if (0.99 < new && new < 1.01) {
+		new = 1.0;
+	}
 
+	if (new > 5.0) {
+		fprintf(stderr, "scale_desktop: not scaling > 5.0: %f\n", new);
+		return;
+	} else if (new < 0.05) {
+		fprintf(stderr, "scale_desktop: not scaling < 0.05: %f\n", new);
+		return;
+	}
+	sprintf(tmp, "%.16f", new);
+	appData.scale = strdup(tmp);
+
+	fs = 0;
+	if (appData.fullScreen) {
+		fs = 1;
+		FullScreenOff();
+	}
+	if (1) {
+		double fx, fy;
+		get_scale_values(&fx, &fy);
+		if (fx > 0.0 && fy > 0.0) {
+			rescale_image();
+		}
+	}
+	if (fs) {
+		FullScreenOn();
+	}
+}
+
+static int escape_mods[8];
+static int escape_drag_in_progress = 0, last_x = 0, last_y = 0;
+static double last_drag = 0.0;
+static double last_key  = 0.0;
+
+static int escape_sequence_pressed(void) {
+	static char *prev = NULL;
+	char *str = "default";
+	int sum, i, init = 0, pressed;
+	static int db = -1;
+
+	if (db < 0) {
+		if (getenv("SSVNC_DEBUG_ESCAPE_KEYS")) {
+			db = 1;
+		} else {
+			db = 0;
+		}
+	}
+
+	if (appData.escapeKeys != NULL) {
+		str = appData.escapeKeys;
+	}
+	if (prev == NULL) {
+		init = 1;
+		prev = strdup(str);
+	} else {
+		if (strcmp(prev, str)) 	{
+			init = 1;
+			free(prev);
+			prev = strdup(str);
+		}
+	}
+	if (db) fprintf(stderr, "str: %s\n", str);
+
+	if (init) {
+		char *p, *s;
+		KeySym ks;
+		int k = 0, failed = 0;
+
+		for (i = 0; i < 8; i++) {
+			escape_mods[i] = -1;
+		}
+
+		if (!strcasecmp(str, "default")) {
+#if (defined(__MACH__) && defined(__APPLE__))
+			s = strdup("Control_L,Meta_L");
+#else
+			s = strdup("Alt_L,Super_L");
+#endif
+		} else {
+			s = strdup(str);
+		}
+		
+		p = strtok(s, ",+ ");
+		while (p) {
+			ks = XStringToKeysym(p);
+			if (ks == XK_Shift_L || ks == XK_Shift_R) {
+				putenv("NO_X11VNC_APPSHARE=1");
+			}
+			if (k >= 8) {
+				fprintf(stderr, "EscapeKeys: more than 8 modifier keys.\n");
+				failed = 1;
+				break;
+			}
+			if (ks == NoSymbol) {
+				fprintf(stderr, "EscapeKeys: failed lookup for '%s'\n", p);
+				failed = 1;
+				break;
+			} else if (!IsModifierKey(ks)) {
+				fprintf(stderr, "EscapeKeys: not a modifier key '%s'\n", p);
+				failed = 1;
+				break;
+			} else {
+				KeyCode kc = XKeysymToKeycode(dpy, ks);
+				if (kc == NoSymbol) {
+					fprintf(stderr, "EscapeKeys: no keycode for modifier key '%s'\n", p);
+					failed = 1;
+					break;
+				}
+				if (db) fprintf(stderr, "set: %d %d\n", k, kc);
+				escape_mods[k++] = kc; 
+			}
+			
+			p = strtok(NULL, ",+ ");
+		}
+		free(s);
+
+		if (failed) {
+			for (i = 0; i < 8; i++) {
+				escape_mods[i] = -1;
+			}
+		}
+	}
+
+	pressed = 1;
+	sum = 0;
+	for (i = 0; i < 8; i++) {
+		int kc = escape_mods[i];
+		if (kc != -1 && kc < 256) {
+			if (db) fprintf(stderr, "try1: %d %d = %d\n", i, kc, modifierPressed[kc]);
+			if (!modifierPressed[kc]) {
+				pressed = 0;
+				break;
+			} else {
+				sum++;
+			}
+		}
+	}
+	if (sum == 0) pressed = 0;
+
+	if (!pressed) {
+		/* user may have dragged mouse outside of toplevel window */
+		int i, k;
+		int keystate[256];
+		char keys[32];
+
+		/* so query server instead of modifierPressed[] */
+		XQueryKeymap(dpy, keys);
+		for (i=0; i<32; i++) {
+			char c = keys[i];
+
+			for (k=0; k < 8; k++) {
+				if (c & 0x1) {
+					keystate[8*i + k] = 1;
+				} else {
+					keystate[8*i + k] = 0;
+				}
+				c = c >> 1;
+			}
+		}
+
+		/* check again using keystate[] */
+		pressed = 2;
+		sum = 0;
+		for (i = 0; i < 8; i++) {
+			int kc = escape_mods[i];
+			if (kc != -1 && kc < 256) {
+				if (db) fprintf(stderr, "try2: %d %d = %d\n", i, kc, keystate[kc]);
+				if (!keystate[kc]) {
+					pressed = 0;
+					break;
+				} else {
+					sum++;
+				}
+			}
+		}
+		if (sum == 0) pressed = 0;
+	}
+
+	return pressed;
+}
+
+static int shift_is_down(void) {
+	int shift_down = 0;
+	KeyCode kc;
+
+	if (appData.viewOnly) {
+		int i, k;
+		char keys[32];
+		int keystate[256];
+
+		XQueryKeymap(dpy, keys);
+		for (i=0; i<32; i++) {
+			char c = keys[i];
+
+			for (k=0; k < 8; k++) {
+				if (c & 0x1) {
+					keystate[8*i + k] = 1;
+				} else {
+					keystate[8*i + k] = 0;
+				}
+				c = c >> 1;
+			}
+		}
+
+		kc = XKeysymToKeycode(dpy, XK_Shift_L);
+		if (kc != NoSymbol && keystate[kc]) {
+			shift_down = 1;
+		} else {
+			kc = XKeysymToKeycode(dpy, XK_Shift_R);
+			if (kc != NoSymbol && keystate[kc]) {
+				shift_down = 1;
+			}
+		}
+		return shift_down;
+	} else {
+		kc = XKeysymToKeycode(dpy, XK_Shift_L);
+		if (kc != NoSymbol && modifierPressed[kc]) {
+			shift_down = 1;
+		} else {
+			kc = XKeysymToKeycode(dpy, XK_Shift_R);
+			if (kc != NoSymbol && modifierPressed[kc]) {
+				shift_down = 1;
+			}
+		}
+		return shift_down;
+	}
+}
+			
 /*
  * SendRFBEvent is an action which sends an RFB event.  It can be used in two
  * ways.  Without any parameters it simply sends an RFB event corresponding to
@@ -201,127 +2089,406 @@
  * button2 down, 3 for both, etc).
  */
 
+extern Bool selectingSingleWindow;
+
+extern Cursor dotCursor3;
+extern Cursor dotCursor4;
+
+extern void set_server_scale(int);
+
 void
 SendRFBEvent(Widget w, XEvent *ev, String *params, Cardinal *num_params)
 {
-  KeySym ks;
-  char keyname[256];
-  int buttonMask, x, y;
-
-  if (appData.fullScreen && ev->type == MotionNotify) {
-    if (BumpScroll(ev))
-      return;
-  }
+	KeySym ks;
+	char keyname[256];
+	int buttonMask, x, y;
+	int do_escape;
+	static int db = -1;
+	char *ek = appData.escapeKeys;
+
+	if (db < 0) {
+		if (getenv("SSVNC_DEBUG_ESCAPE_KEYS")) {
+			db = 1;
+		} else {
+			db = 0;
+		}
+	}
+
+	if (ev->type == MotionNotify || ev->type == KeyRelease) {
+		static double last = 0.0;
+		double now = dnow();
+		if (now > last + 0.25) {
+			check_things();
+			last = now;
+		}
+	}
+
+	if (selectingSingleWindow && ev->type == ButtonPress) {
+		selectingSingleWindow = False;
+		SendSingleWindow(ev->xbutton.x, ev->xbutton.y);
+		if (appData.viewOnly) {
+			XDefineCursor(dpy, desktopWin, dotCursor4);
+		} else {
+			XDefineCursor(dpy, desktopWin, dotCursor3);
+		}
+		return;
+	}
 
-  if (appData.viewOnly) return;
+	if (appData.fullScreen && ev->type == MotionNotify && !escape_drag_in_progress) {
+		if (BumpScroll(ev)) {
+			return;
+		}
+	}
+
+	do_escape = 0;
+	if (ek != NULL && (ek[0] == 'n' || ek[0] == 'N') && !strcasecmp(ek, "never")) {
+		;
+	} else if (appData.viewOnly) {
+		do_escape = 1;
+	} else if (appData.escapeActive) {
+		int skip = 0, is_key = 0;
+
+		if (ev->type == KeyPress || ev->type == KeyRelease) {
+			is_key = 1;
+			XLookupString(&ev->xkey, keyname, 256, &ks, NULL);
+			if (IsModifierKey(ks)) {
+				skip = 1;
+			}
+		}
+		if (!skip) {
+			int es = escape_sequence_pressed();
+			if (es == 1) {
+				do_escape = 1;
+			} else if (es == 2) {
+				if (is_key) {
+					if (dnow() < last_key + 5.0) {
+						do_escape = 1;
+					}
+				} else {
+					if (dnow() < last_drag + 5.0) {
+						do_escape = 1;
+					}
+				}
+			}
+		}
+	}
+	if (!do_escape) {
+		escape_drag_in_progress = 0;
+	}
+	if (db) fprintf(stderr, "do_escape: %d\n", do_escape);
+
+	if (do_escape) {
+		int W = si.framebufferWidth;
+		int H = si.framebufferHeight;
+		int shift_down = 0;
+
+		if (!getenv("NO_X11VNC_APPSHARE")) {
+			shift_down = shift_is_down();
+		}
+		if (db) fprintf(stderr, "shift_down: %d\n", shift_down);
+
+		if (*num_params != 0) {
+			if (strcasecmp(params[0],"fbupdate") == 0) {
+				SendFramebufferUpdateRequest(0, 0, W, H, False);
+			}
+		}
+		if (ev->type == ButtonRelease) {
+			XButtonEvent *b = (XButtonEvent *) ev;
+			if (db) fprintf(stderr, "ButtonRelease: %d %d %d\n", b->x_root, b->y_root, b->state); 
+			if (b->button == 3) {
+				if (shift_down) {
+					x11vnc_appshare("delete");
+				} else {
+					ShowPopup(w, ev, params, num_params);
+				}
+			} else if (escape_drag_in_progress && b->button == 1) {
+				escape_drag_in_progress = 0;
+			}
+		} else if (ev->type == ButtonPress) {
+			XButtonEvent *b = (XButtonEvent *) ev;
+			if (db) fprintf(stderr, "ButtonPress:   %d %d %d\n", b->x_root, b->y_root, b->state); 
+			if (b->button == 1) {
+				if (shift_down) {
+					x11vnc_appshare("position");
+				} else {
+					escape_drag_in_progress = 1;
+					last_x = b->x_root;
+					last_y = b->y_root;
+				}
+			} else {
+				escape_drag_in_progress = 0;
+			}
+		} else if (ev->type == MotionNotify) {
+			XMotionEvent *m = (XMotionEvent *) ev;
+			if (escape_drag_in_progress) {
+				if (db) fprintf(stderr, "MotionNotify:   %d %d %d\n", m->x_root, m->y_root, m->state); 
+				scroll_desktop(m->x_root - last_x, m->y_root - last_y, -1.0);
+				last_x = m->x_root;
+				last_y = m->y_root;
+			}
+		} else if (ev->type == KeyRelease) {
+			int did = 1;
+
+			XLookupString(&ev->xkey, keyname, 256, &ks, NULL);
+			if (ks == XK_1 || ks == XK_KP_1) {
+				set_server_scale(1);
+			} else if (ks == XK_2 || ks == XK_KP_2) {
+				set_server_scale(2);
+			} else if (ks == XK_3 || ks == XK_KP_3) {
+				set_server_scale(3);
+			} else if (ks == XK_4 || ks == XK_KP_4) {
+				set_server_scale(4);
+			} else if (ks == XK_5 || ks == XK_KP_5) {
+				set_server_scale(5);
+			} else if (ks == XK_6 || ks == XK_KP_6) {
+				set_server_scale(6);
+			} else if (ks == XK_r || ks == XK_R) {
+				SendFramebufferUpdateRequest(0, 0, W, H, False);
+			} else if (ks == XK_b || ks == XK_B) {
+				ToggleBell(w, ev, params, num_params);
+			} else if (ks == XK_c || ks == XK_C) {
+				Toggle8bpp(w, ev, params, num_params);
+			} else if (ks == XK_x || ks == XK_X) {
+				ToggleX11Cursor(w, ev, params, num_params);
+			} else if (ks == XK_z || ks == XK_Z) {
+				ToggleTightZRLE(w, ev, params, num_params);
+			} else if (ks == XK_h || ks == XK_H) {
+				ToggleTightHextile(w, ev, params, num_params);
+			} else if (ks == XK_f || ks == XK_F) {
+				ToggleFileXfer(w, ev, params, num_params);
+			} else if (ks == XK_V) {
+				ToggleViewOnly(w, ev, params, num_params);
+			} else if (ks == XK_Q) {
+				Quit(w, ev, params, num_params);
+			} else if (ks == XK_l || ks == XK_L) {
+				ToggleFullScreen(w, ev, params, num_params);
+			} else if (ks == XK_a || ks == XK_A) {
+				ToggleCursorAlpha(w, ev, params, num_params);
+			} else if (ks == XK_s || ks == XK_S) {
+				SetScale(w, ev, params, num_params);
+			} else if (ks == XK_t || ks == XK_T) {
+				ToggleTextChat(w, ev, params, num_params);
+			} else if (ks == XK_e || ks == XK_E) {
+				SetEscapeKeys(w, ev, params, num_params);
+			} else if (ks == XK_g || ks == XK_G) {
+				ToggleXGrab(w, ev, params, num_params);
+			} else if (ks == XK_D) {
+				if (shift_down || appData.appShare) {
+					x11vnc_appshare("delete");
+				}
+			} else if (ks == XK_M) {
+				if (shift_down || appData.appShare) {
+					x11vnc_appshare("position");
+				}
+			} else if (ks == XK_Left) {
+				if (shift_down) {
+					x11vnc_appshare("left");
+				} else {
+					scroll_desktop(-1, 0, 0.1);
+				}
+			} else if (ks == XK_Right) {
+				if (shift_down) {
+					x11vnc_appshare("right");
+				} else {
+					scroll_desktop(+1, 0, 0.1);
+				}
+			} else if (ks == XK_Up) {
+				if (shift_down) {
+					x11vnc_appshare("up");
+				} else {
+					scroll_desktop(0, +1, 0.1);
+				}
+			} else if (ks == XK_Down) {
+				if (shift_down) {
+					x11vnc_appshare("down");
+				} else {
+					scroll_desktop(0, -1, 0.1);
+				}
+			} else if (ks == XK_KP_Left) {
+				if (shift_down) {
+					x11vnc_appshare("left-fine");
+				} else {
+					scroll_desktop(-1, 0, 0.0);
+				}
+			} else if (ks == XK_KP_Right) {
+				if (shift_down) {
+					x11vnc_appshare("right-fine");
+				} else {
+					scroll_desktop(+1, 0, 0.0);
+				}
+			} else if (ks == XK_KP_Up) {
+				if (shift_down) {
+					x11vnc_appshare("up-fine");
+				} else {
+					scroll_desktop(0, +1, 0.0);
+				}
+			} else if (ks == XK_KP_Down) {
+				if (shift_down) {
+					x11vnc_appshare("down-fine");
+				} else {
+					scroll_desktop(0, -1, 0.0);
+				}
+			} else if (ks == XK_Next || ks == XK_KP_Next) {
+				if (shift_down && ks == XK_Next) {
+					x11vnc_appshare("shorter");
+				} else {
+					scroll_desktop(0, -1, 1.0);
+				}
+			} else if (ks == XK_Prior || ks == XK_KP_Prior) {
+				if (shift_down && ks == XK_Prior) {
+					x11vnc_appshare("taller");
+				} else {
+					scroll_desktop(0, +1, 1.0);
+				}
+			} else if (ks == XK_End || ks == XK_KP_End) {
+				if (shift_down && ks == XK_End) {
+					x11vnc_appshare("narrower");
+				} else {
+					scroll_desktop(+1, 0, 1.0);
+				}
+			} else if (ks == XK_Home || ks == XK_KP_Home) {
+				if (shift_down && ks == XK_Home) {
+					x11vnc_appshare("wider");
+				} else {
+					scroll_desktop(-1, 0, 1.0);
+				}
+			} else if (ks == XK_equal || ks == XK_plus) {
+				if (shift_down) {
+					x11vnc_appshare("raise");
+				} else {
+					scale_desktop(1, 0.1);
+				}
+			} else if (ks == XK_underscore || ks == XK_minus) {
+				if (shift_down) {
+					x11vnc_appshare("lower");
+				} else {
+					scale_desktop(0, 0.1);
+				}
+			} else {
+				did = 0;
+			}
+			if (did) {
+				last_key = dnow();
+			}
+		}
+		if (escape_drag_in_progress) {
+			last_drag = dnow();
+		}
+		return;
+	}
+	if (appData.viewOnly) {
+		return;
+	}
+
+	if (*num_params != 0) {
+		if (strncasecmp(params[0],"key",3) == 0) {
+			if (*num_params != 2) {
+				fprintf(stderr, "Invalid params: "
+				    "SendRFBEvent(key|keydown|keyup,<keysym>)\n");
+				return;
+			}
+			ks = XStringToKeysym(params[1]);
+			if (ks == NoSymbol) {
+				fprintf(stderr,"Invalid keysym '%s' passed to "
+				    "SendRFBEvent\n", params[1]);
+				return;
+			}
+			if (strcasecmp(params[0],"keydown") == 0) {
+				SendKeyEvent(ks, 1);
+			} else if (strcasecmp(params[0],"keyup") == 0) {
+				SendKeyEvent(ks, 0);
+			} else if (strcasecmp(params[0],"key") == 0) {
+				SendKeyEvent(ks, 1);
+				SendKeyEvent(ks, 0);
+			} else {
+				fprintf(stderr,"Invalid event '%s' passed to "
+				    "SendRFBEvent\n", params[0]);
+				return;
+			}
+		} else if (strcasecmp(params[0],"fbupdate") == 0) {
+			if (*num_params != 1) {
+				fprintf(stderr, "Invalid params: "
+				    "SendRFBEvent(fbupdate)\n");
+				return;
+			}
+			SendFramebufferUpdateRequest(0, 0, si.framebufferWidth,
+			    si.framebufferHeight, False);
+
+		} else if (strcasecmp(params[0],"ptr") == 0) {
+			if (*num_params == 4) {
+				x = atoi(params[1]);
+				y = atoi(params[2]);
+				buttonMask = atoi(params[3]);
+				SendPointerEvent(x, y, buttonMask);
+			} else if (*num_params == 2) {
+				switch (ev->type) {
+				case ButtonPress:
+				case ButtonRelease:
+					x = ev->xbutton.x;
+					y = ev->xbutton.y;
+					break;
+				case KeyPress:
+				case KeyRelease:
+					x = ev->xkey.x;
+					y = ev->xkey.y;
+					break;
+				default:
+					fprintf(stderr, "Invalid event caused "
+					    "SendRFBEvent(ptr,<buttonMask>)\n");
+					return;
+				}
+				buttonMask = atoi(params[1]);
+				SendPointerEvent(x, y, buttonMask);
+			} else {
+				fprintf(stderr, "Invalid params: "
+				    "SendRFBEvent(ptr,<x>,<y>,<buttonMask>)\n"
+				    "             or SendRFBEvent(ptr,<buttonMask>)\n");
+				return;
+			}
+		} else {
+			fprintf(stderr,"Invalid event '%s' passed to "
+			    "SendRFBEvent\n", params[0]);
+		}
+		return;
+	}
 
-  if (*num_params != 0) {
-    if (strncasecmp(params[0],"key",3) == 0) {
-      if (*num_params != 2) {
-	fprintf(stderr,
-		"Invalid params: SendRFBEvent(key|keydown|keyup,<keysym>)\n");
-	return;
-      }
-      ks = XStringToKeysym(params[1]);
-      if (ks == NoSymbol) {
-	fprintf(stderr,"Invalid keysym '%s' passed to SendRFBEvent\n",
-		params[1]);
-	return;
-      }
-      if (strcasecmp(params[0],"keydown") == 0) {
-	SendKeyEvent(ks, 1);
-      } else if (strcasecmp(params[0],"keyup") == 0) {
-	SendKeyEvent(ks, 0);
-      } else if (strcasecmp(params[0],"key") == 0) {
-	SendKeyEvent(ks, 1);
-	SendKeyEvent(ks, 0);
-      } else {
-	fprintf(stderr,"Invalid event '%s' passed to SendRFBEvent\n",
-		params[0]);
-	return;
-      }
-    } else if (strcasecmp(params[0],"fbupdate") == 0) {
-      if (*num_params != 1) {
-	fprintf(stderr, "Invalid params: SendRFBEvent(fbupdate)\n");
-	return;
-      }
-      SendFramebufferUpdateRequest(0, 0, si.framebufferWidth,
-				   si.framebufferHeight, False);
-    } else if (strcasecmp(params[0],"ptr") == 0) {
-      if (*num_params == 4) {
-	x = atoi(params[1]);
-	y = atoi(params[2]);
-	buttonMask = atoi(params[3]);
-	SendPointerEvent(x, y, buttonMask);
-      } else if (*num_params == 2) {
 	switch (ev->type) {
+	case MotionNotify:
+		while (XCheckTypedWindowEvent(dpy, desktopWin, MotionNotify, ev)) {
+			;	/* discard all queued motion notify events */
+		}
+
+		SendPointerEvent(ev->xmotion.x, ev->xmotion.y,
+			     (ev->xmotion.state & 0x1f00) >> 8);
+		return;
+
 	case ButtonPress:
+		SendPointerEvent(ev->xbutton.x, ev->xbutton.y,
+			     (((ev->xbutton.state & 0x1f00) >> 8) |
+			      (1 << (ev->xbutton.button - 1))));
+		return;
+
 	case ButtonRelease:
-	  x = ev->xbutton.x;
-	  y = ev->xbutton.y;
-	  break;
+		SendPointerEvent(ev->xbutton.x, ev->xbutton.y,
+			     (((ev->xbutton.state & 0x1f00) >> 8) &
+			      ~(1 << (ev->xbutton.button - 1))));
+		return;
+
 	case KeyPress:
 	case KeyRelease:
-	  x = ev->xkey.x;
-	  y = ev->xkey.y;
-	  break;
-	default:
-	  fprintf(stderr,
-		  "Invalid event caused SendRFBEvent(ptr,<buttonMask>)\n");
-	  return;
-	}
-	buttonMask = atoi(params[1]);
-	SendPointerEvent(x, y, buttonMask);
-      } else {
-	fprintf(stderr,
-		"Invalid params: SendRFBEvent(ptr,<x>,<y>,<buttonMask>)\n"
-		"             or SendRFBEvent(ptr,<buttonMask>)\n");
-	return;
-      }
-
-    } else {
-      fprintf(stderr,"Invalid event '%s' passed to SendRFBEvent\n", params[0]);
-    }
-    return;
-  }
-
-  switch (ev->type) {
+		XLookupString(&ev->xkey, keyname, 256, &ks, NULL);
 
-  case MotionNotify:
-    while (XCheckTypedWindowEvent(dpy, desktopWin, MotionNotify, ev))
-      ;	/* discard all queued motion notify events */
-
-    SendPointerEvent(ev->xmotion.x, ev->xmotion.y,
-		     (ev->xmotion.state & 0x1f00) >> 8);
-    return;
-
-  case ButtonPress:
-    SendPointerEvent(ev->xbutton.x, ev->xbutton.y,
-		     (((ev->xbutton.state & 0x1f00) >> 8) |
-		      (1 << (ev->xbutton.button - 1))));
-    return;
-
-  case ButtonRelease:
-    SendPointerEvent(ev->xbutton.x, ev->xbutton.y,
-		     (((ev->xbutton.state & 0x1f00) >> 8) &
-		      ~(1 << (ev->xbutton.button - 1))));
-    return;
-
-  case KeyPress:
-  case KeyRelease:
-    XLookupString(&ev->xkey, keyname, 256, &ks, NULL);
-
-    if (IsModifierKey(ks)) {
-      ks = XKeycodeToKeysym(dpy, ev->xkey.keycode, 0);
-      modifierPressed[ev->xkey.keycode] = (ev->type == KeyPress);
-    }
+		if (IsModifierKey(ks)) {
+			ks = XKeycodeToKeysym(dpy, ev->xkey.keycode, 0);
+			modifierPressed[ev->xkey.keycode] = (ev->type == KeyPress);
+		}
 
-    SendKeyEvent(ks, (ev->type == KeyPress));
-    return;
+		SendKeyEvent(ks, (ev->type == KeyPress));
+		return;
 
-  default:
-    fprintf(stderr,"Invalid event passed to SendRFBEvent\n");
-  }
+	default:
+		fprintf(stderr,"Invalid event passed to SendRFBEvent\n");
+	}
 }
 
 
